#include <gb.h>

// g`̃WX^`
#define VW30_REG	(*(UBYTE *)0xFF30)	/* Sound register */
#define VW31_REG	(*(UBYTE *)0xFF31)	/* Sound register */
#define VW32_REG	(*(UBYTE *)0xFF32)	/* Sound register */
#define VW33_REG	(*(UBYTE *)0xFF33)	/* Sound register */
#define VW34_REG	(*(UBYTE *)0xFF34)	/* Sound register */
#define VW35_REG	(*(UBYTE *)0xFF35)	/* Sound register */
#define VW36_REG	(*(UBYTE *)0xFF36)	/* Sound register */
#define VW37_REG	(*(UBYTE *)0xFF37)	/* Sound register */
#define VW38_REG	(*(UBYTE *)0xFF38)	/* Sound register */
#define VW39_REG	(*(UBYTE *)0xFF39)	/* Sound register */
#define VW3A_REG	(*(UBYTE *)0xFF3A)	/* Sound register */
#define VW3B_REG	(*(UBYTE *)0xFF3B)	/* Sound register */
#define VW3C_REG	(*(UBYTE *)0xFF3C)	/* Sound register */
#define VW3D_REG	(*(UBYTE *)0xFF3D)	/* Sound register */
#define VW3E_REG	(*(UBYTE *)0xFF3E)	/* Sound register */
#define VW3F_REG	(*(UBYTE *)0xFF3F)	/* Sound register */

#define SND_TRACK_MAX  5
#define SND_FLAG_VW    0x01

/*
// `l
NR52_REG = 0x8F;// b7:S`lON=1 / b3-0:`l4`1ĐtOON=F(1111)
NR50_REG = 0x77;// b7:VinOF=0F / b6-4:=7 / b3:EVinOFF=0 / b2-0:E=7
NR51_REG = 0xFF;// b7-4:`l4`1oON=F(1111) / b3-0:`l4`1EoON=F(1111)
// `l1(`gXC[v)
NR10_REG = 0x00;// b6-4:XC[v=0 / b3:XC[v=0() / b2-0:XC[vω=0
NR11_REG = 0xC0;// b7-6:f[eB=3 / b5-0:JE^=0
NR12_REG = 0xF0;// b7-4:=15 / b3:Gx[v=0() / b2-0:Gx[vPʎ=0
NR13_REG = 0x0A;// b7-0:g(11rbg̉8rbg)
NR14_REG = 0x86;// b7:JntO=1 / b6:JE^ĐtO=0 / b2-0:g(11rbg̏3rbg)
// `l2(`g)
NR21_REG = 0xC0;// b7-6:f[eB=3 / b5-0:JE^=0
NR22_REG = 0xF0;// b7-4:=15 / b3:Gx[v=0() / b2-0:Gx[vPʎ=0
NR23_REG = 0xB2;// b7-0:g(11rbg̉8rbg)
NR24_REG = 0x86;// b7:JntO=1 / b6:JE^ĐtO=0 / b2-0:g(11rbg̏3rbg)
// `l3(g`)
NR30_REG = 0x80;// b7:oON=1
NR31_REG = 0x00;// b7-0:=0
NR32_REG = 0x20;// b6-5: 100%o=1 ~[g(0%o)=0A50%o=2A25%o=3
NR33_REG = 0x72;// b7-0:g(11rbg̉8rbg)
NR34_REG = 0x86;// b7:JntO=1 / b6:JE^ĐtO=0 / b2-0:g(11rbg̏3rbg)
// `l4(mCY)
NR41_REG = 0x00;// b5-0:=0
NR42_REG = 0xF3;// b7-4:=15 / b3:Gx[v=0() / b2-0:Gx[vPʎ=3
NR43_REG = 0x33;// b7-4:gVtg=3 / b3:JE^P(0:15/1:7)=0 / b2-0:g=7
NR44_REG = 0x80;// b7:JntO=1 / b6:JE^ĐtO=0
*/

struct st_track {
	UBYTE ch;   // `l(1`4)
	UBYTE play; // ĐtO
	UBYTE on;   // ON/OFFtO(=1Ax=0)
	UBYTE vol;  // (0`15)`l3̔g`0`3(~[g(0%o=0A100%o=1A50%o=2A25%o=3)
	UBYTE duty; // f[eB(0`3)
	UBYTE pan;  // p|bg(0`3)=0A=1AE=2A=3
	UBYTE tmp;  // e|(1`8)
	UBYTE len;  // ftHg
	UBYTE cnt;  // JE^
	UBYTE oct;  // IN^[u(0`5)
	UBYTE scl;  // K(0`11)C,C+,D,D+,E,F,F+,G,G+,A,A+,B
	UBYTE note; // IN^[u~K(0`71)
	UBYTE flag; // tO b0:g`]tO
	UBYTE *pp;  // Đ|C^
	UBYTE *lp;  // [v|C^
	UBYTE *rp1; // s[g1|C^
	UBYTE rpc1; // s[g1JE^
	UBYTE *rp2; // s[g2|C^
	UBYTE rpc2; // s[g2JE^
	UBYTE detn; // f`[l
	UBYTE lfo;  // LFOx
	UBYTE lfoc; // LFOJE^
	UBYTE vibm; // ru[gől
	UBYTE vibe; // ru[gݒl
	UBYTE mute; // ~[gtO
	UBYTE env;  // Gx[v
	UBYTE swep; // XC[v
	UWORD freq; // g
};

// TEhR}h
#define SNDENV		0xEE // 0xEEFGx[vw
						 // 	, ݒl
#define SNDSWEEP	0xEF // 0xEFFXC[vw
						 // 	, ݒl
#define SNDTONE		0xF0 // 0xF0FFw
						 // 	, Fԍ
#define SNDREP1ST	0xF1 // 0xF1Fs[g1JnJE^
#define SNDREP1ED	0xF2 // 0xF2Fs[g1IJE^CNg
						 // 	, s[g
#define SNDREP2ST	0xF3 // 0xF3Fs[g2JnJE^
#define SNDREP2ED	0xF4 // 0xF4Fs[g2IJE^CNg
						 // 	, s[g
#define SNDLOOPST	0xF5 // 0xF5F[vJnʒuAhXL^
#define SNDLOOPED	0xF6 // 0xF6F[vIʒuAhXWv
#define SNDTEMPO	0xF7 // 0xF7Fe|w
 						 // 	, e|ԍi0`9:e|lj
#define SNDTIE		0xF8 // 0xF8F^Cw
						 // 	, 
#define SNDVOL		0xF9 // 0xF9Fʎw
						 // 	, ݒli0`15j
#define SNDDETUNE	0xFA // 0xFAFf`[w
						 // 	, ݒl
#define SNDVIBE		0xFB // 0xFBFru[gw
						 // 	, ݒl
						 // 	, ǉĐ
#define SNDLFO		0xFC // 0xFCFLFOxw
						 // 	, ݒl
#define SNDLONG		0xFD // 0xFDFȗw
						 // i	, SNDTEMPO,e|ԍi0`9:e|ljj
						 // 	, ԍ
#define SNDPAN		0xFE // 0xFEFp|bgw
						 // 	, ݒl
#define SNDEND		0xFF // 0xFFFI

#define SNDLEN32	0x70
#define SNDLEN16	0x71
#define SNDLEN16F	0x72
#define SNDLEN8		0x73
#define SNDLEN8F	0x74
#define SNDLEN4		0x75
#define SNDLEN4F	0x76
#define SNDLEN2		0x77
#define SNDLEN2F	0x78
#define SNDLEN1		0x79

#define NL	0x00

#define CN0	0x01
#define CS0	0x02
#define DN0	0x03
#define DS0	0x04
#define EN0	0x05
#define FN0	0x06
#define FS0	0x07
#define GN0	0x08
#define GS0	0x09
#define AN0	0x0A
#define AS0	0x0B
#define BN0	0x0C

#define CN1	0x0D
#define CS1	0x0E
#define DN1	0x0F
#define DS1	0x10
#define EN1	0x11
#define FN1	0x12
#define FS1	0x13
#define GN1	0x14
#define GS1	0x15
#define AN1	0x16
#define AS1	0x17
#define BN1	0x18

#define CN2	0x19
#define CS2	0x1A
#define DN2	0x1B
#define DS2	0x1C
#define EN2	0x1D
#define FN2	0x1E
#define FS2	0x1F
#define GN2	0x20
#define GS2	0x21
#define AN2	0x22
#define AS2	0x23
#define BN2	0x24

#define CN3	0x25
#define CS3	0x26
#define DN3	0x27
#define DS3	0x28
#define EN3	0x29
#define FN3	0x2A
#define FS3	0x2B
#define GN3	0x2C
#define GS3	0x2D
#define AN3	0x2E
#define AS3	0x2F
#define BN3	0x30

#define CN4	0x31
#define CS4	0x32
#define DN4	0x33
#define DS4	0x34
#define EN4	0x35
#define FN4	0x36
#define FS4	0x37
#define GN4	0x38
#define GS4	0x39
#define AN4	0x3A
#define AS4	0x3B
#define BN4	0x3C

#define CN5	0x3D
#define CS5	0x3E
#define DN5	0x3F
#define DS5	0x40
#define EN5	0x41
#define FN5	0x42
#define FS5	0x43
#define GN5	0x44
#define GS5	0x45
#define AN5	0x46
#define AS5	0x47
#define BN5	0x48

#define CN6	0x49
